# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetHelmValuesResult',
    'AwaitableGetHelmValuesResult',
    'get_helm_values',
    'get_helm_values_output',
]

@pulumi.output_type
class GetHelmValuesResult:
    """
    A collection of values returned by getHelmValues.
    """
    def __init__(__self__, id=None, namespace=None, release=None, yaml=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if namespace and not isinstance(namespace, str):
            raise TypeError("Expected argument 'namespace' to be a str")
        pulumi.set(__self__, "namespace", namespace)
        if release and not isinstance(release, str):
            raise TypeError("Expected argument 'release' to be a str")
        pulumi.set(__self__, "release", release)
        if yaml and not isinstance(yaml, str):
            raise TypeError("Expected argument 'yaml' to be a str")
        pulumi.set(__self__, "yaml", yaml)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def namespace(self) -> Optional[str]:
        """
        Namespace of cilium (Default: `kube-system`).
        """
        return pulumi.get(self, "namespace")

    @property
    @pulumi.getter
    def release(self) -> Optional[str]:
        """
        Helm release (Default: `Install`).
        """
        return pulumi.get(self, "release")

    @property
    @pulumi.getter
    def yaml(self) -> str:
        """
        Yaml output
        """
        return pulumi.get(self, "yaml")


class AwaitableGetHelmValuesResult(GetHelmValuesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetHelmValuesResult(
            id=self.id,
            namespace=self.namespace,
            release=self.release,
            yaml=self.yaml)


def get_helm_values(namespace: Optional[str] = None,
                    release: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetHelmValuesResult:
    """
    Helm values of cilium

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cilium as cilium
    import pulumi_local as local

    example_helm_values = cilium.get_helm_values()
    example_file = local.File("exampleFile",
        content=example_helm_values.yaml,
        filename=f"{path['module']}/values.yaml")
    ```


    :param str namespace: Namespace of cilium (Default: `kube-system`).
    :param str release: Helm release (Default: `Install`).
    """
    __args__ = dict()
    __args__['namespace'] = namespace
    __args__['release'] = release
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cilium:index/getHelmValues:getHelmValues', __args__, opts=opts, typ=GetHelmValuesResult).value

    return AwaitableGetHelmValuesResult(
        id=pulumi.get(__ret__, 'id'),
        namespace=pulumi.get(__ret__, 'namespace'),
        release=pulumi.get(__ret__, 'release'),
        yaml=pulumi.get(__ret__, 'yaml'))


@_utilities.lift_output_func(get_helm_values)
def get_helm_values_output(namespace: Optional[pulumi.Input[Optional[str]]] = None,
                           release: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetHelmValuesResult]:
    """
    Helm values of cilium

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cilium as cilium
    import pulumi_local as local

    example_helm_values = cilium.get_helm_values()
    example_file = local.File("exampleFile",
        content=example_helm_values.yaml,
        filename=f"{path['module']}/values.yaml")
    ```


    :param str namespace: Namespace of cilium (Default: `kube-system`).
    :param str release: Helm release (Default: `Install`).
    """
    ...
